Index: src/test/display/MdrDisplay.java
===================================================================
--- src/test/display/MdrDisplay.java	(revision 573)
+++ src/test/display/MdrDisplay.java	(working copy)
@@ -12,17 +12,22 @@
  */
 package test.display;
 
-import java.io.UnsupportedEncodingException;
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
+import java.nio.ByteBuffer;
+import java.nio.CharBuffer;
 import java.nio.charset.Charset;
+import java.nio.charset.StandardCharsets;
 import java.util.ArrayList;
 import java.util.Arrays;
+import java.util.BitSet;
 import java.util.Iterator;
 import java.util.LinkedHashMap;
+import java.util.LinkedList;
 import java.util.List;
 import java.util.Map;
 
+import uk.me.parabola.imgfmt.app.ImgFileReader;
 import uk.me.parabola.imgfmt.app.srt.Sort;
 
 /**
@@ -46,9 +51,15 @@
 	private int citySizeFlagged;
 	private Charset charSet;
 	private Map<Integer, String> stringTable;
+	private BitSet stringOffsets = new BitSet();
+	private List<Integer> depths = new ArrayList<>();
+	
 	private int start;
 	private int record;
 
+	private HuffNode root;
+
+	@Override
 	protected void print() {
 		readCommonHeader();
 
@@ -63,6 +74,9 @@
 		 * none is found then a generic method is used to print the
 		 * section
 		 */
+		if (compressedStrings) 
+			printSect16();
+		
 		for (int i = 1; i < numberOfSections(); i++) {
 			if (!want(i))
 				continue;
@@ -79,6 +93,19 @@
 				e.printStackTrace();
 			}
 		}
+//		int last =-1;
+//		for (int i = stringOffsets.nextSetBit(0); i >= 0; i = stringOffsets.nextSetBit(i+1)) {
+//			if (last >=0) {
+//				int delta = i - last;
+//				if (delta <= 2) {
+//					DisplayItem d = new DisplayItem();
+//					d.addText("offset: %x (len: %d)", last, delta);
+//					d.print(outStream);
+//				}
+//			}
+//			last = i;
+//		}
+//		long dd = 4;
 	}
 
 	/**
@@ -115,6 +142,7 @@
 		int sublen;
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect1() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 1 (maps)");
@@ -167,6 +195,7 @@
 	/**
 	 * A list of POI types without subtypes
 	 */
+	@SuppressWarnings("unused")
 	private void printSect3() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 3 (polygon types)");
@@ -191,6 +220,7 @@
 	/**
 	 * A list of POI types.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect4() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 4 (POI types)");
@@ -303,6 +333,7 @@
 	/**
 	 * A list of zips.  It is alphabetically arranged.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect6() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 6 (ZIPs)");
@@ -332,6 +363,7 @@
 	/**
 	 * Contains an ordered list of pointers to street names.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect7() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 7 (street names)");
@@ -383,6 +415,7 @@
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect8() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 8 (index into streets)");
@@ -392,6 +425,7 @@
 	/**
 	 * POI / Polygon groups.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect9() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 9 (Index into mdr10, grouped based on type)");
@@ -416,6 +450,7 @@
 	/**
 	 * POI types.  Also has a pointer into MDR 11.  Seems like a waste.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect10() {
 		// Looks variable length
 		Displayer d = new Displayer(reader);
@@ -507,6 +542,7 @@
 	 * and the offset in LBL.  If it has an associated city (or is a city itself), there is
 	 * a reference back into MDR 5.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect11() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 11 (POIs)");
@@ -546,6 +582,7 @@
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect12() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 12 (index into POI)");
@@ -579,6 +616,7 @@
 	 * This is an ordered list containing pointers into the text strings,
 	 * probably for regions, arranged per map.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect13() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 13 (regions)");
@@ -608,6 +646,7 @@
 	/**
 	 * Countries for each map.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect14() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 14 (country)");
@@ -635,6 +674,7 @@
 	 * There are two formats possible, this is the simple straightforward
 	 * one.  There is an alternate one that is compressed in some way.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect15() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 15 (strings)");
@@ -646,7 +686,7 @@
 		reader.position(start);
 
 		if (compressedStrings) {
-			// don't currently know this
+			// strings are compressed with Huffman encoding
 			d.rawValue((int) (end - start));
 		} else {
 			// If we have already read the strings then don't bother to do it all again.
@@ -669,11 +709,12 @@
 	 * This is some kind of codebook which is used to decode the strings
 	 * in MDR 15 if they are compressed.
 	 */
+	@SuppressWarnings("unused")
 	private void printSect16() {
 		if (!compressedStrings) 
 			return;
 		Displayer d = new Displayer(reader);
-		d.setTitle("MDR 16 (decompression codebook?)");
+		d.setTitle("MDR 16 (decompression codebook Huffman tree)");
 
 		Section s = getSection(16);
 		long start = s.getStart();
@@ -680,12 +721,162 @@
 		long end = s.getEnd();
 		d.setSectStart(start);
 		reader.position(start);
-
+		DisplayItem item = d.byteItem();
+		item.addText("???");
+		item = d.byteItem();
+		item.addText("???");
+		item = d.byteItem();
+		item.addText("???");
+		item = d.byteItem();
+		int lastLevel = item.getValue();
+		item.addText("1st level with struct: %d", item.getValue());
+		item = d.rawItem(lastLevel > 16 ? 6:5);
+		item.addText("???");
+		int level;
+		BitSet bs = new BitSet();
+		
+		int count = 0;
+		int structBytes = lastLevel > 16 ? 3: 2;
+		int lastCount = 0;
+		List<Mdr16Tab> levels = new ArrayList<>();
+		for (int i = 0; i <= lastLevel; i++) {
+			levels.add(new Mdr16Tab());
+		}
+		do {
+			item = d.byteItem();
+			level = item.getValue();
+			item.addText("struct level: %d", item.getValue());
+			item = d.byteItem();
+			count = item.getValue();
+			int delta = count - lastCount;
+			long off1 = end - count + 1;
+			item.addText("count byte %d, delta = %d", item.getValue(), delta);
+			item = d.intItem(structBytes);
+			item.addText("struct for %d", level);
+			Mdr16Tab levelDesc = levels.get(level);
+			levelDesc.depth = level;
+			levelDesc.offset = count;
+			
+			lastCount = count;
+		} while (level > 6);
+		int skip = 7;
+		if (lastLevel == 0x10)
+			skip = 12;
+		if (lastLevel == 0x12)
+			skip = 5;
+		item = d.rawItem(skip);
+		item.addText("???");
+		List<LinkedList<Byte>> levelVals = new ArrayList<>();
+		for (int i = 0; i <= lastLevel; i++)
+			levelVals.add(new LinkedList<>());
+		int prefix;
+		while (true) {
+			prefix = reader.get();
+			reader.position(reader.position() - 1);
+			if (prefix != 7 && prefix != 9 && prefix != 0xb) {
+				break;
+			}
+			
+			item = d.byteItem();
+			prefix = item.getValue();
+			item.addText("prefix %x", item.getValue());
+			item = d.byteItem();
+			int val = (char) item.getValue();
+			item.addText("value in tree '%c' (0x%x)", val, val);
+			
+			if (prefix == 0x0b)
+				levelVals.get(5).add((byte) val);
+			else if (prefix == 0x09) {
+				LinkedList<Byte> lst = levelVals.get(4);
+				if (lst.isEmpty() || lst.getLast() != val)
+					lst.add((byte) val);
+			} else if (prefix == 0x07) {
+				LinkedList<Byte> lst = levelVals.get(3);
+				if (lst.isEmpty() || lst.getLast() != val)
+					lst.add((byte) val);
+			} 
+		} 
+		if (root != null)
+			d.print(outStream);
+		
+		
+		long posRest = reader.position();
+		long lastOff = 0;
+		for (int i = 0; i < levels.size(); i++) {
+			Mdr16Tab info = levels.get(i);
+			int len;
+			if (info.depth == 0)
+				continue;
+			if (lastOff == 0)
+				len = (int) (end - reader.position()) - info.offset;
+			else
+				len = (int) (lastOff - info.offset);
+			lastOff = info.offset;
+			reader.position(posRest + info.offset);
+			if (len < 0) {
+				outStream.print("failed to read Huffman tree in MDR section 16");
+				break;
+			}
+			LinkedList<Byte> lst = levelVals.get(info.depth);
+			for (int k = 0; k < len; k++)
+				lst.add(reader.get());
+		}
 		// don't currently know this
+		reader.position(start);
 		d.rawValue((int) (end - start));
-		d.print(outStream);
+//		if (root != null)
+			d.print(outStream);
+		buldHuffman(levelVals);
+		long dd = 4;
+//		
+//		getTextString(1);
+
 	}
 
+	private void buldHuffman(List<LinkedList<Byte>> levelVals) {
+		root = null;
+		int code = -1;
+		boolean firstCode = true;
+		byte[] bb = {0};
+		for (int i = 0; i < levelVals.size(); i++) {
+			LinkedList<Byte> vals = levelVals.get(i);
+			long dd = 4;
+			if (firstCode)
+				code = 1 << i;
+			else 
+				code <<= 1;
+			if (!vals.isEmpty()) {
+				firstCode = false;
+				while (!vals.isEmpty()) {
+					code--;
+					String x = Integer.toBinaryString(code);
+					if (x.length() < i) {
+						// add leading zeros to code
+						x = "0000000000000000000000000000000000000".substring(0, i - x.length()) + x;
+					}
+					bb[0] = vals.removeLast();
+					CharBuffer cbuf = charSet.decode(ByteBuffer.wrap(bb)); 
+					char v = cbuf.get();
+					outStream.print(x + " 0x" + Integer.toHexString(bb[0] & 0xff) + "'" + v +"'\n");
+					outStream.flush();
+					addHuffmanNode(x, v);
+				}
+			} else {
+				long dd1 = 4;
+			}
+		}
+	}
+
+	private static class Mdr16Tab {
+		int depth;
+		int offset;
+		
+		@Override
+		public String toString() {
+			// TODO Auto-generated method stub
+			return "depth=" + depth + ", offset=" + offset;
+		}
+	}
 	/**
 	 * MDR 17: String table
 	 *
@@ -692,6 +883,7 @@
 	 * My personal guess is, that this is a search table for
 	 * sub strings starting with the given short string
 	 */
+	@SuppressWarnings("unused")
 	private void printSect17() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 17 (indexes based on initial sub strings)");
@@ -760,6 +952,7 @@
 	/**
 	 * MDR 18: Looks like a mapping to MDR 11 or MDR 19
 	 */
+	@SuppressWarnings("unused")
 	private void printSect18() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 18 (poi type index into 19)");
@@ -782,6 +975,7 @@
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect19() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 19 (poi sorted by type)");
@@ -888,19 +1082,23 @@
 		d.print(outStream);
 
 	}
-
+	
+	@SuppressWarnings("unused")
 	private void printSect20() {
 		printSect2x("MDR 20 (streets by city)", 20);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect21() {
 		printSect2x("MDR 21 (streets by region)", 21);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect22() {
 		printSect2x("MDR 22 (streets by country)", 22);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect23() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 23 (sorted regions)");
@@ -930,6 +1128,7 @@
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect24() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 24 (sorted countries)");
@@ -958,6 +1157,7 @@
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect25() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 25 (cities by country)");
@@ -986,6 +1186,7 @@
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect26() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 26 (mdr28 ordered by country)");
@@ -1018,6 +1219,7 @@
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect27() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 27 (cities by region?)");
@@ -1046,6 +1248,7 @@
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect28() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 28 (region names with pointers)");
@@ -1091,6 +1294,7 @@
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect29() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 29 (country names with pointers)");
@@ -1149,7 +1353,19 @@
 			d.item().addText("max %d", m);
 		d.print(outStream);
 	}
+	
+	/** used with 30/31 and 32/33 */
+	private void displayString(int sectNum, int lastOff, int off, Displayer d) {
+		long saveOff = reader.position();
 
+		reader.position(getSection(sectNum).getStart()+ lastOff);
+		byte[] bytes = reader.get(off - lastOff);
+		DisplayItem item = d.item();
+		item.addText("mdr%d string: %s", sectNum, new String(bytes, StandardCharsets.ISO_8859_1));
+		reader.position(saveOff);
+	}
+
+	@SuppressWarnings("unused")
 	private void printSect30() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 30 (pointers to mdr31)");
@@ -1164,33 +1380,30 @@
 
 		reader.position(s.getStart());
 
-		long start;
 		int lastOff = 0;
+		int maxOff = s31.getLen();
+		int mask = 0xff;
+		while (mask < maxOff) {
+			mask <<= 8;
+			mask += 0xff;
+		}
 		while (reader.position() < s.getEnd()) {
-			System.out.println("GOT " + reader.position());
-
 			int off = d.intValue(recsize, "Offset in mdr31: %d") & 0xffff;
+			if (off > maxOff)
+				off = off & mask;
 			if (off > 0) {
-
-				long saveOff = reader.position();
-
-				reader.position(s31.getStart() + lastOff);
-				byte[] bytes = reader.get(off - lastOff);
-				DisplayItem item = d.item();
-				try {
-					item.addText("mdr31 string: %s", new String(bytes, "latin1"));
-				} catch (UnsupportedEncodingException e) {
-					item.addText("Cannot decode string");
-				}
-
-				reader.position(saveOff);
+				displayString(31, lastOff, off, d);
 				lastOff = off;
 			}
-
 		}
+		// remaining data
+		if (lastOff < maxOff) {
+			displayString(31, lastOff, maxOff, d);
+		}
 		d.print(outStream);
 	}
 
+	@SuppressWarnings("unused")
 	private void printSect32() {
 		Displayer d = new Displayer(reader);
 		d.setTitle("MDR 32 (pointers to mdr33)");
@@ -1204,29 +1417,27 @@
 
 		reader.position(s.getStart());
 
-		long start;
 		int lastOff = 0;
+		int maxOff = s33.getLen();
+		int mask = 0xff;
+		while (mask < maxOff) {
+			mask <<= 8;
+			mask += 0xff;
+		}
 		while (reader.position() < s.getEnd()) {
 
 			int off = d.intValue(recsize, "Offset in mdr33: %d");
+			if (off > maxOff)
+				off = off & mask;
 			if (off > 0) {
-
-				long saveOff = reader.position();
-
-				reader.position(s33.getStart() + lastOff);
-				byte[] bytes = reader.get(off - lastOff);
-				DisplayItem item = d.item();
-				try {
-					item.addText("mdr33 string: %s", new String(bytes, "latin1"));
-				} catch (UnsupportedEncodingException e) {
-					item.addText("Cannot decode string");
-				}
-
-				reader.position(saveOff);
+				displayString(33, lastOff, off, d);
 				lastOff = off;
 			}
-
 		}
+		// remaining data
+		if (lastOff < maxOff) {
+			displayString(33, lastOff, maxOff, d);
+		}
 		d.print(outStream);
 	}
 
@@ -1263,15 +1474,212 @@
 	 */
 	private String getTextString(int off) {
 		if (compressedStrings) {
-			return "(offset: " + off + ")";
+//			if (root == null) {
+//				// depth 3, prefix 0x07: 111
+//				addHuffmanNode("111", 'A'); 
+//				
+//				// depth 4, prefix 0x09: 1001
+//				addHuffmanNode("0111", '\0'); // 0x00
+//				addHuffmanNode("1000", ' '); //0x20
+//				addHuffmanNode("1001", 'E'); 
+//				addHuffmanNode("1010", 'N');
+//				addHuffmanNode("1011", 'O');
+//				addHuffmanNode("1100", 'I');
+//				addHuffmanNode("1101", 'R'); 
+//				
+//				// depth 5, prefix 0x0b: 1101
+//				addHuffmanNode("00101", 'C');
+//				addHuffmanNode("00110", 'S');
+//				addHuffmanNode("00111", 'D');
+//				addHuffmanNode("01000", 'T');
+//				addHuffmanNode("01001", 'M');
+//				addHuffmanNode("01010", 'V');
+//				addHuffmanNode("01011", 'J');
+//				addHuffmanNode("01100", 'K');
+//				addHuffmanNode("01101", 'L');
+//				// depth 6
+//				addHuffmanNode("000101", 'G');
+//				addHuffmanNode("000110", 'Z');
+//				addHuffmanNode("000111", 'U');
+//				addHuffmanNode("001000", 'P');
+//				addHuffmanNode("001001", 'B');
+//				// depth 7
+//				addHuffmanNode("0000110", 'H');
+//				addHuffmanNode("0000111", '1');
+//				addHuffmanNode("0001000", '2');
+//				addHuffmanNode("0001001", '.');
+//				// depth 8
+//				addHuffmanNode("00000011", '5');
+//				addHuffmanNode("00000100", '6');
+//				addHuffmanNode("00000101", '-');
+//				addHuffmanNode("00000110", '7');
+//				addHuffmanNode("00000111", '3');
+//				addHuffmanNode("00001000", '8');
+//				addHuffmanNode("00001001", '9');
+//				addHuffmanNode("00001010", '0');
+//				addHuffmanNode("00001011", '4');
+//				// depth 9
+//				addHuffmanNode("000000010", 'F');
+//				addHuffmanNode("000000011",',');
+//				addHuffmanNode("000000100", '(');
+//				addHuffmanNode("000000101", ')');
+//				// depth 10
+//				addHuffmanNode("0000000011", '*');
+//				// depth 11
+//				addHuffmanNode("00000000011", 'Y');
+//				addHuffmanNode("00000000100", '"');
+//				addHuffmanNode("00000000101", (char) 0x06); // non-print4
+//				// depth 12
+//				addHuffmanNode("000000000011", 'W');
+//				addHuffmanNode("000000000100", 'X');
+//				addHuffmanNode("000000000101", (char) 0x05); //non-print some shield code
+//				// depth 13
+//				addHuffmanNode("0000000000100", '&');
+//				addHuffmanNode("0000000000101", (char) 0x1f); //non-print2
+//				// depth 14
+//				addHuffmanNode("00000000000011", 'Q');
+//				addHuffmanNode("00000000000100", 'Š'); 
+//				addHuffmanNode("00000000000101", '\''); // mdr16 says 0x8a
+//				addHuffmanNode("00000000000110", 'Ë'); 
+//				addHuffmanNode("00000000000111", '/');
+//				// depth 15
+//				addHuffmanNode("000000000000100", 'Æ');
+//				addHuffmanNode("000000000000101", 'È');
+//				// depth 16
+//				addHuffmanNode("0000000000000101", (char) 0x04); // non-print3
+//				addHuffmanNode("0000000000000110", '!'); 
+//				addHuffmanNode("0000000000000111", (char) 0x9e); //Ž
+//				// depth 17
+//				addHuffmanNode("00000000000000110",'+');
+//				addHuffmanNode("00000000000000111", '–'); // different to minus mdr16: 0x96
+//				addHuffmanNode("00000000000001000", 'Á'); //Á
+//				addHuffmanNode("00000000000001001", 'Ü'); 
+//				// depth 18
+//				addHuffmanNode("000000000000000110", '_');  
+//				addHuffmanNode("000000000000000111", '{');
+//				addHuffmanNode("000000000000001000", '“'); // mdr16: 0x93
+//				addHuffmanNode("000000000000001001", 'É');
+//				addHuffmanNode("000000000000001010", 'Ð'); 
+//				addHuffmanNode("000000000000001011", 'Ö');
+//				// depth 19
+//				addHuffmanNode("0000000000000000011", '?'); 
+//				addHuffmanNode("0000000000000000100", '`'); // mdr16: 0x60
+//				addHuffmanNode("0000000000000000101", '„'); // mdr16: 0x84
+//				addHuffmanNode("0000000000000000110", 'ž'); // mdr16: 0x8e 
+//				addHuffmanNode("0000000000000000111", '’'); // mdr16: 0x92
+//				addHuffmanNode("0000000000000001000", 'Ä');
+//				addHuffmanNode("0000000000000001001", 'Ø');
+//				addHuffmanNode("0000000000000001010", 'Ú'); 
+//				addHuffmanNode("0000000000000001011", 'Û');
+//				// depth 20
+//				addHuffmanNode("00000000000000000000", '#'); // offset into MDR 30/31? MapSource displays "HWY " 
+//				addHuffmanNode("00000000000000000001", '%'); // 
+//				addHuffmanNode("00000000000000000010", ':');
+//				addHuffmanNode("00000000000000000011", ';');
+//				addHuffmanNode("00000000000000000100", (char) 0x8f);
+//				addHuffmanNode("00000000000000000101", (char) 0xb8);
+//				StringBuilder vals = new StringBuilder();
+//				StringBuilder struct = new StringBuilder();
+//				int minDepth = 3;
+//				int maxDepth = 21;
+//				for (int depth = maxDepth; depth >= minDepth; depth--) {
+//					struct.setLength(0);
+//					displayHuffman(0, depth, vals, struct, root);
+//					String chars = vals.toString();
+//					outStream.print("depth " + depth + " :>" + chars + "< num: " + vals.length() + "\n");
+//					outStream.flush();
+//					vals.setLength(0);
+//					
+//				}
+//				int count = 0;
+//				for (int i = 0; i< struct.length(); i++) {
+//					if (struct.charAt(i) == '0') {
+//						count++;
+//					}
+//				}
+//				BitSet bs = new BitSet();
+////				for (int i = 200; i > 0; i--) {
+////					if (i % 4 == 0 && i < struct.length())
+////						struct.insert(i, ' ');
+////				}
+//				String s = struct.toString();
+//				outStream.print("struct " + s+ "\n");
+//				outStream.flush();
+//				for (int i = 0; i < s.length();i++) {
+//					if (s.charAt(i) == '1')
+//						bs.set(i);
+//				}
+//				byte[] bytes = bs.toByteArray();
+//				long dd = 4;
+//			}
+			stringOffsets.set(off);
+			long mdr15Start = getSection(15).getStart();
+			long savePos = reader.position();
+			reader.position(mdr15Start + off);
+			String s = decode(reader); 
+			reader.position(savePos);
+			return s + "(offset: " + off + ")";
 		}
-
+		
 		if (stringTable == null)
 			readAllStrings();
 
 		return stringTable.get(off);
 	}
+	
+	/** pre-order-traversal */
+	private void displayHuffman(int depth, int wantedDepth, StringBuilder vals, StringBuilder struct, HuffNode node) {
+		if (node.ch != null && wantedDepth == depth) {
+			vals.append(node.ch);
+		}
+		struct.append(node.ch != null ? '1' : '0');
+		if (node.left != null)
+			displayHuffman(depth + 1, wantedDepth, vals, struct, node.left);
+		if (node.right != null)
+			displayHuffman(depth + 1, wantedDepth, vals, struct, node.right);
+	}
 
+	String decode (ImgFileReader reader) {
+		StringBuilder sb = new StringBuilder();
+		StringBuilder code = new StringBuilder();
+		int mask = 0;
+		byte b = 0;
+		HuffNode next = root;
+		long lastOff = getSection(15).getEnd();
+		while (true) {
+			if (reader.position() > lastOff) {
+				return sb.toString();
+			}
+			if (next == null) {
+				sb.append('?');
+				return sb.toString();
+			}
+			if (next.ch != null) {
+				if (next.ch == 0)
+					return sb.toString();
+				if (next.ch == '#') {
+					long dd = 4;
+				}
+				
+				sb.append(next.ch);
+				next = root;
+				code.setLength(0);
+			}
+			if (mask == 0) {
+				mask = 0x80;
+				b = reader.get();
+			}
+			int bit = (b & mask) == 0 ? 0 : 1;
+			code.append(bit == 1 ? '1' : '0');
+			mask >>= 1;
+			if (next.ch == null) {
+				next = bit == 0 ? next.left : next.right; 
+			} else {
+				long dd = 4;
+			}
+		}
+	}
+
 	private void readAllStrings() {
 		if (compressedStrings)
 			return;  // we don't know how to do this yet.
@@ -1488,7 +1896,62 @@
 
 		if (!hasNumber)
 			Arrays.fill(md.wanted, true);
-
 		md.display(name, "MDR");
 	}
-}
+	
+	static class HuffNode {
+		Character ch;
+		
+		HuffNode left = null, right = null;
+
+		HuffNode(Character ch) {
+			this.ch = ch;
+		}
+
+		public HuffNode(Character ch, HuffNode left, HuffNode right) {
+			this.ch = ch;
+			this.left = left;
+			this.right = right;
+		}
+	}
+	
+	void addHuffmanNode(String bits, char v) {
+		if (root == null) {
+			root = new HuffNode(null, null, null);
+		}
+		HuffNode next = root;
+		if (v == 'Û') {
+			long dd = 4;
+		}
+		int depth = 0;
+		while (!bits.isEmpty()) {
+			depth++;
+			if ((next.left != null || next.right != null) && next.ch != null) {
+				throw new IllegalArgumentException("bad tree:" + v);
+			}
+			char bit = bits.charAt(0);
+			bits = bits.substring(1);
+			if (bit == '0') {
+				if (next.left == null)
+					next.left = new HuffNode(null, null, null);
+				else {
+					if (next.ch != null)
+						throw new IllegalArgumentException("bad tree:" + v);
+				}
+				next = next.left;
+			} else {
+				if (next.right == null)
+					next.right = new HuffNode(null, null, null); 
+				else {
+					if (next.ch != null)
+						throw new IllegalArgumentException("bad tree:" + v);
+				}
+				next = next.right;
+			}
+		}
+		if (next.ch != null || next.left != null || next.right != null)
+			throw new IllegalArgumentException("bad tree:" + v);
+		next.ch = v;
+	}
+	
+}
\ No newline at end of file
